searchData={"items":[{"type":"module","title":"AbsintheFieldTelemetry","doc":"A library for analysing absinthe GraphQL runtime usage.","ref":"AbsintheFieldTelemetry.html"},{"type":"module","title":"Installation - AbsintheFieldTelemetry","doc":"The package can be installed by adding `absinthe_field_telemetry` to your list\n  of dependencies in `mix.exs`:\n\n  ```elixir\n  def deps do\n  [\n    {:absinthe_field_telemetry, \"~> 0.2.5\"}\n  ]\n  end\n  ```\n\n  Add a call to the setup function in your application setup\n\n  ```elixir\n  AbsintheFieldTelemetry.setup()\n  ```\n\n  Add `AbsintheFieldTelemetry.Middleware` to all the fields on the schema. The\n  easiest way to achieve this is using the [`middleware/3` callback](https://hexdocs.pm/absinthe/Absinthe.Middleware.html#module-the-middleware-3-callback):\n\n  ```elixir\n  def middleware(middleware, _field, _object), do: [AbsintheFieldTelemetry.Middleware | middleware]\n  ```\n\n  Add the dashboard to your router.\n\n  ```elixir\n  import AbsintheFieldTelemetry.Web.Router\n  absinthe_field_telemetry_dashboard \"/absinthe_field_telemetry_dashboard\"\n  ```","ref":"AbsintheFieldTelemetry.html#module-installation"},{"type":"function","title":"AbsintheFieldTelemetry.get_field_hits/1","doc":"","ref":"AbsintheFieldTelemetry.html#get_field_hits/1"},{"type":"function","title":"AbsintheFieldTelemetry.get_path_hits/1","doc":"","ref":"AbsintheFieldTelemetry.html#get_path_hits/1"},{"type":"module","title":"AbsintheFieldTelemetry.Application","doc":"AbsintheFieldTelemetry application, responsible for starting the backend workers.\n\nConfigured with the `:absinthe_field_telemetry` environment key:\n\n- `:backend`, a tuple of `{module, config}`\n\nDifferent backends take different options, see the documentation for the given backend for more details.\n\nExample backend:\n\n    config :absinthe_field_telemetry,\n      backend: {AbsintheFieldTelemetry.Backend.ETS, []}","ref":"AbsintheFieldTelemetry.Application.html"},{"type":"function","title":"AbsintheFieldTelemetry.Application.start/2","doc":"","ref":"AbsintheFieldTelemetry.Application.html#start/2"},{"type":"behaviour","title":"AbsintheFieldTelemetry.Backend","doc":"The backend of AbsintheFieldTelemetry.\n\n  Contains details of the callbacks required for a backend.","ref":"AbsintheFieldTelemetry.Backend.html"},{"type":"function","title":"AbsintheFieldTelemetry.Backend.get_all_field_hits/1","doc":"","ref":"AbsintheFieldTelemetry.Backend.html#get_all_field_hits/1"},{"type":"callback","title":"AbsintheFieldTelemetry.Backend.get_all_field_hits/1","doc":"","ref":"AbsintheFieldTelemetry.Backend.html#c:get_all_field_hits/1"},{"type":"function","title":"AbsintheFieldTelemetry.Backend.get_all_path_hits/1","doc":"","ref":"AbsintheFieldTelemetry.Backend.html#get_all_path_hits/1"},{"type":"callback","title":"AbsintheFieldTelemetry.Backend.get_all_path_hits/1","doc":"","ref":"AbsintheFieldTelemetry.Backend.html#c:get_all_path_hits/1"},{"type":"function","title":"AbsintheFieldTelemetry.Backend.record_field_hits/2","doc":"","ref":"AbsintheFieldTelemetry.Backend.html#record_field_hits/2"},{"type":"callback","title":"AbsintheFieldTelemetry.Backend.record_field_hits/2","doc":"","ref":"AbsintheFieldTelemetry.Backend.html#c:record_field_hits/2"},{"type":"function","title":"AbsintheFieldTelemetry.Backend.record_path_hits/2","doc":"","ref":"AbsintheFieldTelemetry.Backend.html#record_path_hits/2"},{"type":"callback","title":"AbsintheFieldTelemetry.Backend.record_path_hits/2","doc":"","ref":"AbsintheFieldTelemetry.Backend.html#c:record_path_hits/2"},{"type":"function","title":"AbsintheFieldTelemetry.Backend.reset/1","doc":"","ref":"AbsintheFieldTelemetry.Backend.html#reset/1"},{"type":"callback","title":"AbsintheFieldTelemetry.Backend.reset/1","doc":"","ref":"AbsintheFieldTelemetry.Backend.html#c:reset/1"},{"type":"type","title":"AbsintheFieldTelemetry.Backend.field/0","doc":"","ref":"AbsintheFieldTelemetry.Backend.html#t:field/0"},{"type":"type","title":"AbsintheFieldTelemetry.Backend.field_hits/0","doc":"","ref":"AbsintheFieldTelemetry.Backend.html#t:field_hits/0"},{"type":"type","title":"AbsintheFieldTelemetry.Backend.field_identifier/0","doc":"","ref":"AbsintheFieldTelemetry.Backend.html#t:field_identifier/0"},{"type":"type","title":"AbsintheFieldTelemetry.Backend.path/0","doc":"","ref":"AbsintheFieldTelemetry.Backend.html#t:path/0"},{"type":"type","title":"AbsintheFieldTelemetry.Backend.path_hits/0","doc":"","ref":"AbsintheFieldTelemetry.Backend.html#t:path_hits/0"},{"type":"type","title":"AbsintheFieldTelemetry.Backend.schema/0","doc":"","ref":"AbsintheFieldTelemetry.Backend.html#t:schema/0"},{"type":"type","title":"AbsintheFieldTelemetry.Backend.t/0","doc":"","ref":"AbsintheFieldTelemetry.Backend.html#t:t/0"},{"type":"type","title":"AbsintheFieldTelemetry.Backend.type_identifier/0","doc":"","ref":"AbsintheFieldTelemetry.Backend.html#t:type_identifier/0"},{"type":"module","title":"AbsintheFieldTelemetry.Backend.Batch","doc":"This implementation of the backend is provided to be a wrapper around\n  another backend.\n\n  The idea related to this backend is that it will cache field and path hits\n  in memory and then report them in batches of size `threshold` the other\n  backend.\n  \n  This is designed to improve performance and throughput when a backend\n  requires a network call.\n\n  The backend process is started by calling `start_link`:\n\n      AbsintheFieldTelemetry.Backend.Batch.start_link(\n        threshold: 10_000,\n        interval_ms: 60_000 * 10,\n        backend: {AbsintheFieldTelemetry.Backend.Ets, []}\n      )\n\n  Options are:\n\n  - `interval_ms`: If set, this backend will report all unreported cached hits\n    every `interval_ms`.\n  - `threshold`: The number of hits to cash before reporting the backend (required)\n  - `backend`: The persistence backend (required)","ref":"AbsintheFieldTelemetry.Backend.Batch.html"},{"type":"function","title":"AbsintheFieldTelemetry.Backend.Batch.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"AbsintheFieldTelemetry.Backend.Batch.html#child_spec/1"},{"type":"function","title":"AbsintheFieldTelemetry.Backend.Batch.get_config!/2","doc":"","ref":"AbsintheFieldTelemetry.Backend.Batch.html#get_config!/2"},{"type":"function","title":"AbsintheFieldTelemetry.Backend.Batch.start/1","doc":"","ref":"AbsintheFieldTelemetry.Backend.Batch.html#start/1"},{"type":"function","title":"AbsintheFieldTelemetry.Backend.Batch.start_link/1","doc":"","ref":"AbsintheFieldTelemetry.Backend.Batch.html#start_link/1"},{"type":"function","title":"AbsintheFieldTelemetry.Backend.Batch.stop/0","doc":"","ref":"AbsintheFieldTelemetry.Backend.Batch.html#stop/0"},{"type":"type","title":"AbsintheFieldTelemetry.Backend.Batch.t/0","doc":"","ref":"AbsintheFieldTelemetry.Backend.Batch.html#t:t/0"},{"type":"module","title":"AbsintheFieldTelemetry.Backend.Ets","doc":"A AbsintheFieldTelemetry.Backend implementation using ets.","ref":"AbsintheFieldTelemetry.Backend.Ets.html"},{"type":"function","title":"AbsintheFieldTelemetry.Backend.Ets.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"AbsintheFieldTelemetry.Backend.Ets.html#child_spec/1"},{"type":"function","title":"AbsintheFieldTelemetry.Backend.Ets.start/1","doc":"","ref":"AbsintheFieldTelemetry.Backend.Ets.html#start/1"},{"type":"function","title":"AbsintheFieldTelemetry.Backend.Ets.start_link/1","doc":"","ref":"AbsintheFieldTelemetry.Backend.Ets.html#start_link/1"},{"type":"function","title":"AbsintheFieldTelemetry.Backend.Ets.stop/0","doc":"","ref":"AbsintheFieldTelemetry.Backend.Ets.html#stop/0"},{"type":"module","title":"AbsintheFieldTelemetry.Backend.Redis","doc":"Documentation for AbsintheFieldTelemetry.Backend.Redis\n\nThis backend uses the [Redix](https://hex.pm/packages/redix) library to connect to Redis.\n\nThe backend process is started by calling `start_link`:\n\n    AbsintheFieldTelemetry.Backend.Redis.start_link(\n      expiry_ms: 60_000 * 10,\n      redix_config: [host: \"example.com\", port: 5050]\n    )\n\nOptions are:\n\n- `expiry_ms`: Expiry time of buckets in milliseconds,\n  used to set TTL on Redis keys. This configuration is mandatory.\n- `support_client_commands`: If the server does not support client commands\n  it not possible to use noreply type commands and this value should be set\n  to `false`. Default: `true`.\n- `redix_config`: Keyword list of options to the `Redix` redis client,\n  also aliased to `redis_config`\n- `key_prefix`: The prefix to use for all the redis keys (defaults to \"AbsintheFieldTelemetry:Redis:\")\n- `redis_url`: String url of redis server to connect to\n  (optional, invokes Redix.start_link/2)","ref":"AbsintheFieldTelemetry.Backend.Redis.html"},{"type":"function","title":"AbsintheFieldTelemetry.Backend.Redis.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"AbsintheFieldTelemetry.Backend.Redis.html#child_spec/1"},{"type":"function","title":"AbsintheFieldTelemetry.Backend.Redis.start/1","doc":"","ref":"AbsintheFieldTelemetry.Backend.Redis.html#start/1"},{"type":"function","title":"AbsintheFieldTelemetry.Backend.Redis.start_link/1","doc":"","ref":"AbsintheFieldTelemetry.Backend.Redis.html#start_link/1"},{"type":"function","title":"AbsintheFieldTelemetry.Backend.Redis.stop/0","doc":"","ref":"AbsintheFieldTelemetry.Backend.Redis.html#stop/0"},{"type":"function","title":"AbsintheFieldTelemetry.Backend.Redis.with_expire_command/4","doc":"","ref":"AbsintheFieldTelemetry.Backend.Redis.html#with_expire_command/4"},{"type":"type","title":"AbsintheFieldTelemetry.Backend.Redis.t/0","doc":"","ref":"AbsintheFieldTelemetry.Backend.Redis.html#t:t/0"},{"type":"module","title":"AbsintheFieldTelemetry.Middleware","doc":"Absinthe middleware for adding telemetry for usage of fields in a GraphQL schema.\n\n  Add `AbsintheFieldTelemetry.Middleware` to all the fields on the schema. The\n  easiest way to achieve this is using the [`middleware/3` callback](https://hexdocs.pm/absinthe/Absinthe.Middleware.html#module-the-middleware-3-callback):\n\n```elixir\ndef middleware(middleware, _field, _object), do: [AbsintheFieldTelemetry.Middleware | middleware]\n```","ref":"AbsintheFieldTelemetry.Middleware.html"},{"type":"function","title":"AbsintheFieldTelemetry.Middleware.record_path_hit/2","doc":"","ref":"AbsintheFieldTelemetry.Middleware.html#record_path_hit/2"},{"type":"module","title":"AbsintheFieldTelemetry.Supervisor","doc":"Top-level Supervisor for the AbsintheFieldTelemetry application.\n\n  Starts and supervises the backend","ref":"AbsintheFieldTelemetry.Supervisor.html"},{"type":"function","title":"AbsintheFieldTelemetry.Supervisor.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"AbsintheFieldTelemetry.Supervisor.html#child_spec/1"},{"type":"function","title":"AbsintheFieldTelemetry.Supervisor.init/1","doc":"","ref":"AbsintheFieldTelemetry.Supervisor.html#init/1"},{"type":"function","title":"AbsintheFieldTelemetry.Supervisor.start_link/2","doc":"","ref":"AbsintheFieldTelemetry.Supervisor.html#start_link/2"},{"type":"module","title":"AbsintheFieldTelemetry.Web.Router","doc":"The absinthe_field_telemetry_dashboard macro can be used to add the\n  dashboard to your router, as follows:\n\n  ```elixir\n  import AbsintheFieldTelemetry.Web.Router\n  absinthe_field_telemetry_dashboard \"/absinthe_field_telemetry_dashboard\"\n  ```","ref":"AbsintheFieldTelemetry.Web.Router.html"},{"type":"macro","title":"AbsintheFieldTelemetry.Web.Router.absinthe_field_telemetry_dashboard/2","doc":"","ref":"AbsintheFieldTelemetry.Web.Router.html#absinthe_field_telemetry_dashboard/2"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,52,46,49]}}